<?php 
// $Id: search.inc.php,v 1.7 2003/03/25 11:08:20 liquid Exp $
// ------------------------------------------------------------------------ //
// XOOPS - PHP Content Management System                      //
// Copyright (c) 2000 XOOPS.org                           //
// <http://www.xoops.org/>                             //
// ------------------------------------------------------------------------ //
// This program is free software; you can redistribute it and/or modify     //
// it under the terms of the GNU General Public License as published by     //
// the Free Software Foundation; either version 2 of the License, or        //
// (at your option) any later version.                                      //
// //
// You may not change or alter any portion of this comment or credits       //
// of supporting developers from this source code or any supporting         //
// source code which is considered copyrighted (c) material of the          //
// original comment or credit authors.                                      //
// //
// This program is distributed in the hope that it will be useful,          //
// but WITHOUT ANY WARRANTY; without even the implied warranty of           //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
// GNU General Public License for more details.                             //
// //
// You should have received a copy of the GNU General Public License        //
// along with this program; if not, write to the Free Software              //
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
// ------------------------------------------------------------------------ //
function wfdownloads_search($queryarray, $andor, $limit, $offset, $userid)
{
    global $xoopsDB, $xoopsUser;
	
    $sql = "SELECT lid, cid, title, submitter, published, description FROM " . $xoopsDB -> prefix("wfdownloads_downloads") . " 
	WHERE status >0 AND published > 0";
    if ($userid != 0)
    {
        $sql .= " AND submitter=" . $userid . " ";
    } 
    // because count() returns 1 even if a supplied variable
    // is not an array, we must check if $querryarray is really an array
    if (is_array($queryarray) && $count = count($queryarray))
    {
        $sql .= " AND ((title LIKE '%$queryarray[0]%' OR description LIKE '%$queryarray[0]%')";
        for($i = 1;$i < $count;$i++)
        {
            $sql .= " $andor ";
            $sql .= "(title LIKE '%$queryarray[$i]%' OR description LIKE '%$queryarray[$i]%')";
        } 
        $sql .= ") ";
    } 
    $sql .= "ORDER BY date DESC";
    $result = $xoopsDB -> query($sql, $limit, $offset);
    $ret = array();
    $i = 0;

    $groups = (is_object($xoopsUser)) ? $xoopsUser -> getGroups() : XOOPS_GROUP_ANONYMOUS;
    $modhandler = & xoops_gethandler('module');
    $xoopsWFDModule = & $modhandler -> getByDirname("wfdownloads");
    $gperm_handler = & xoops_gethandler('groupperm');

    while ($myrow = $xoopsDB -> fetchArray($result))
    {
        if (!$gperm_handler -> checkRight('WFDownFilePerm', $myrow['cid'] , $groups, $xoopsWFDModule -> getVar('mid')))
            Continue;
        $ret[$i]['image'] = "images/size2.gif";
        $ret[$i]['link'] = "singlefile.php?cid=" . $myrow['cid'] . "&amp;lid=" . $myrow['lid'] . "";
        $ret[$i]['title'] = $myrow['title'];
        $ret[$i]['time'] = $myrow['published'];
        $ret[$i]['uid'] = $myrow['submitter'];
        $i++;
    } 
    return $ret;
} 

?>
