<?php
/**
 * $Id: brokendown.php v 1.03 06 july 2004 Liquid Exp $
 * Module: WF-Downloads
 * Version: v2.0.4
 * Release Date: 11 july 2004
 * Author: WF-Sections
 * Licence: GNU
 */

include 'admin_header.php';

$op = '';

if (!isset($_POST['op']))
{
    $op = isset($_GET['op']) ? $_GET['op'] : 'listBrokenDownloads';
} 
else
{
    $op = $_POST['op'];
} 

$lid = (isset($_GET['lid'])) ? $_GET['lid'] : 0;

switch ($op)
{
    case "updateNotice":
        global $xoopsDB;

        if (isset($_GET['ack']))
        {
            $acknowledged = (isset($_GET['ack']) && $_GET['ack'] == 0) ? 1 : 0;
            $xoopsDB->queryF("UPDATE " . $xoopsDB->prefix("wfdownloads_broken") . " SET acknowledged = '$acknowledged'
				WHERE lid='$lid'");
            $update_mess = _AM_BROKEN_NOWACK;
        } 

        if (isset($_GET['con']))
        {
            $confirmed = (isset($_GET['con']) && $_GET['con'] == 0) ? 1 : 0;
            $xoopsDB->queryF("UPDATE " . $xoopsDB->prefix("wfdownloads_broken") . " SET confirmed = '$confirmed' 
			WHERE lid='$lid'");
            $update_mess = _AM_BROKEN_NOWCON;
        } 
        redirect_header("brokendown.php?op=default", 1, $update_mess);
        break;

    case "delBrokenDownloads":
        global $xoopsDB;

        $xoopsDB->queryF("DELETE FROM " . $xoopsDB->prefix("wfdownloads_broken") . " WHERE lid = '$lid'");
        $xoopsDB->queryF("DELETE FROM " . $xoopsDB->prefix("wfdownloads_downloads") . " WHERE lid = '$lid'");
        redirect_header("brokendown.php?op=default", 1, _AM_BROKENFILEDELETED);
        exit();
        break;

    case "ignoreBrokenDownloads":
        global $xoopsDB;

        $xoopsDB->queryF("DELETE FROM " . $xoopsDB->prefix("wfdownloads_broken") . " WHERE lid = '$lid'");
        redirect_header("brokendown.php?op=default", 1, _AM_BROKEN_FILEIGNORED);
        break;

    case "listBrokenDownloads":
    case "default":

        global $xoopsDB, $imagearray, $xoopsModule;
        $result = $xoopsDB->query("SELECT * FROM " . $xoopsDB->prefix("wfdownloads_broken") . " ORDER BY reportid");
        $totalbrokendownloads = $xoopsDB->getRowsNum($result);

        xoops_cp_header();

        wfd_adminmenu(_AM_BROKEN_FILE);

        echo "<fieldset><legend style='font-weight: bold; color: #900;'>" . _AM_BROKEN_REPORTINFO . "</legend>";
        echo "<div style='padding: 8px;'>" . _AM_BROKEN_REPORTSNO . "&nbsp;<b>$totalbrokendownloads</b><div>";
        echo "<div div style='padding: 8px;'>
			<li>" . $imagearray['ignore'] . " " . _AM_BROKEN_IGNOREDESC . "
			<li>" . $imagearray['editimg'] . " " . _AM_BROKEN_DELETEDESC . "
			<li>" . $imagearray['deleteimg'] . " " . _AM_BROKEN_EDITDESC . "</div>";
        echo "</fieldset><br >";

        echo"<table width='100%' border='0' cellspacing='1' cellpadding = '2' class='outer'>";
        echo "<tr align = 'center'>";
        echo "<th width = '3%' align = 'center'>" . _AM_BROKEN_ID . "</th>";
        echo "<th width = '35%' align = 'left'>" . _AM_BROKEN_TITLE . "</th>";
        echo "<th>" . _AM_BROKEN_REPORTER . "</th>";
        echo "<th>" . _AM_BROKEN_FILESUBMITTER . "</th>";
        echo "<th>" . _AM_BROKEN_DATESUBMITTED . "</th>";
        echo "<th align='center'>" . _AM_BROKEN_ACTION . "</th>";
        echo "</tr>";

        if ($totalbrokendownloads == 0)
        {
            echo "<tr align = 'center'><td align = 'center' class='head' colspan = '6'>" . _AM_BROKEN_NOFILEMATCH . "</td></tr>";
        } 
        else
        {
            while (list($reportid, $lid, $sender, $ip, $date, $confirmed, $acknowledged) = $xoopsDB->fetchRow($result))
            {
                $result2 = $xoopsDB->query("SELECT cid, title, url, submitter FROM " . $xoopsDB->prefix("wfdownloads_downloads") . " WHERE lid=$lid");
                list($cid, $fileshowname, $url, $submitter) = $xoopsDB->fetchRow($result2);

                if ($sender != 0)
                {
                    $result3 = $xoopsDB->query("SELECT uname, email FROM " . $xoopsDB->prefix("users") . " WHERE uid=" . $sender . "");
                    list($sendername, $email) = $xoopsDB->fetchRow($result3);
                } 

                $result4 = $xoopsDB->query("SELECT uname, email FROM " . $xoopsDB->prefix("users") . " WHERE uid=" . $sender . "");
                list($ownername, $owneremail) = $xoopsDB->fetchRow($result4);

                echo "<tr align = 'center'>
					<td class = 'head'>$reportid</td>
					<td class = 'even'  align = 'left'><a href='" . XOOPS_URL . "/modules/" . $xoopsModule->dirname() . "/singlefile.php?cid=" . $cid . "&amp;lid=" . $lid . "' target=\"_blank\">" . $fileshowname . "</a></td>";
                if ($email == "")
                {
                    echo "<td class = 'even'>$sendername ($ip)";
                } 
                else
                {
                    echo "<td class = 'even'><a href=mailto:$email>$sendername</a> ($ip)";
                } 
                if ($owneremail == '')
                {
                    echo "<td class = 'even'>$ownername";
                } 
                else
                {
                    echo "<td class = 'even'><a href=mailto:$owneremail>$ownername</a>";
                } 
                echo "</td>";
                echo "<td class = 'even'  align = 'center'>" . formatTimestamp($date, $xoopsModuleConfig['dateformat']) . "</td>";

                echo "<td align='center' class = 'even' nowrap:>";
                echo "<a href='brokendown.php?op=ignoreBrokenDownloads&lid=$lid'>" . $imagearray['ignore'] . "</a>";
                echo "<a href='index.php?op=Download&lid=" . $lid . "'> " . $imagearray['editimg'] . " </a>";
                echo "<a href='brokendown.php?op=delBrokenDownloads&lid=$lid'>" . $imagearray['deleteimg'] . "</a>";
                $ack_image = ($acknowledged) ? $imagearray['ack_yes'] : $imagearray['ack_no'];
                echo "<a href='brokendown.php?op=updateNotice&lid=$lid&ack=$acknowledged'>" . $ack_image . " </a>";
                $con_image = ($confirmed) ? $imagearray['con_yes'] : $imagearray['con_no'];
                echo "<a href='brokendown.php?op=updateNotice&lid=$lid&con=$confirmed'>" . $con_image . " </a>";
                echo "</td></tr>";
            } 
        } 
        echo"</table>";
} 
xoops_cp_footer();

?>
