<?php
/**
 * $Id: main.php v 1.15 02 july 2004 Liquid Exp $
 * Module: WF-Downloads
 * Version: v2.0.4
 * Release Date: 11 july 2004
 * Author: WF-Sections
 * Licence: GNU
 */ 

// Module Info
// The name of this module
define("_MI_WFDOWNLOADS_NAME","WF-Downloads");

// A brief description of this module
define("_MI_WFDOWNLOADS_DESC","Creates a downloads section where users can download/submit/rate various files.");

// Names of blocks for this module (Not all module has blocks)
define("_MI_WFDOWNLOADS_BNAME1","Recent WF-Downloads");
define("_MI_WFDOWNLOADS_BNAME2","Top WF-Downloads");

// Sub menu titles
define("_MI_WFDOWNLOADS_SMNAME1","Submit");
define("_MI_WFDOWNLOADS_SMNAME2","Popular");
define("_MI_WFDOWNLOADS_SMNAME3","Top Rated");

// Names of admin menu items
define("_MI_WFDOWNLOADS_BINDEX","Main Index");
define("_MI_WFDOWNLOADS_INDEXPAGE","Index Page Management");
define("_MI_WFDOWNLOADS_MCATEGORY","Category Management");
define("_MI_WFDOWNLOADS_MDOWNLOADS","File Management");
define("_MI_WFDOWNLOADS_MUPLOADS","Image Upload");
define("_MI_WFDOWNLOADS_MMIMETYPES","Mimetypes Management");
define("_MI_WFDOWNLOADS_PERMISSIONS","Permission Settings");
define("_MI_WFDOWNLOADS_BLOCKADMIN","Block Settings");
define("_MI_WFDOWNLOADS_MVOTEDATA","Votes");

// Title of config items
define('_MI_WFDOWNLOADS_POPULAR', 'Number of hits for downloadable items to be marked as popular');
define('_MI_WFDOWNLOADS_NEWDLS', 'Maximum number of new download items displayed on top page');
define('_MI_WFDOWNLOADS_PERPAGE', 'Maximum number of download items displayed on each page');
define('_MI_WFDOWNLOADS_USESHOTS', 'Select yes to display screenshot images for each download item');
define('_MI_WFDOWNLOADS_SHOTWIDTH', 'Maximum width of screenshot/thumbnails images');
define('_MI_WFDOWNLOADS_SHOTHEIGHT', 'Maximum height of screenshot/thumbnails images');
define('_MI_WFDOWNLOADS_CHECKHOST', 'Disallow direct download linking? (leeching)');
define('_MI_WFDOWNLOADS_REFERERS', 'These sites can directly link to your files <br />Separate with | ');
define("_MI_WFDOWNLOADS_ANONPOST","Allow anonymous users to post download items?");
define('_MI_WFDOWNLOADS_AUTOAPPROVE','Auto approve new downloads without admin intervention?');
define('_MI_WFDOWNLOADS_MAXFILESIZE','Maximum upload size');
define('_MI_WFDOWNLOADS_IMGWIDTH','Maximum upload Image width');
define('_MI_WFDOWNLOADS_IMGHEIGHT','Maximum upload Image height');
define('_MI_WFDOWNLOADS_UPLOADDIR','Upload Directory (No trailing slash)');
define('_MI_WFDOWNLOADS_MIMETYPES','Allowed Mimetypes for Upload');
define('_MI_WFDOWNLOADS_ALLOWSUBMISS','Allow user submissions?');
define('_MI_WFDOWNLOADS_ALLOWUPLOADS','Allow user uploads?');
define('_MI_WFDOWNLOADS_SCREENSHOTS','Screen Shots Upload Directory');
define('_MI_WFDOWNLOADS_CATEGORYIMG','Category Image Upload Directory');
define('_MI_WFDOWNLOADS_MAINIMGDIR','Main Image Directory');
define('_MI_WFDOWNLOADS_USETHUMBS', 'Thumb Nails:');
define('_MI_WFDOWNLOADS_DATEFORMAT', 'Choose Date Format:');
define('_MI_WFDOWNLOADS_SHOWDISCLAIMER', 'Show Disclaimer before User Submission?');
define('_MI_WFDOWNLOADS_SHOWDOWNDISCL', 'Show Disclaimer before User Download?');
define('_MI_WFDOWNLOADS_DISCLAIMER', 'Enter Submission Disclaimer Text:');
define('_MI_WFDOWNLOADS_DOWNDISCLAIMER', 'Enter Download Disclaimer Text:');
define('_MI_WFDOWNLOADS_PLATFORM', 'Enter Platforms:');
define('_MI_WFDOWNLOADS_EMPTYCATS', 'Empty Categories:');
define('_MI_WFDOWNLOADS_SUBCATS', 'Sub-Categories:');
define('_MI_WFDOWNLOADS_VERSIONTYPES', 'Version Status:');
define('_MI_WFDOWNLOADS_LICENSE', 'Enter License:');
define('_MI_WFDOWNLOADS_LIMITS', 'Enter File Limitations:');
define("_MI_WFDOWNLOADS_SUBMITART", "Select Groups who can submit new files:");
define("_MI_WFDOWNLOADS_IMGUPDATE", "Update Thumbnails?");
define("_MI_WFDOWNLOADS_IMGUPDATEDSC", "If selected Thumbnail images will be updated at each page render, otherwise the first thumbnail image will be used regardless. <br /><br />");
define("_MI_WFDOWNLOADS_QUALITY", "Thumb Nail Quality: ");
define("_MI_WFDOWNLOADS_KEEPASPECT", "Keep Image Aspect Ratio?");
define("_MI_WFDOWNLOADS_KEEPASPECTDSC", "");
define("_MI_WFDOWNLOADS_ADMINPAGE", "Admin Index Files Count:");
define("_MI_WFDOWNLOADS_AMDMINPAGEDSC", "Number of new files to display in module admin area.");
define("_MI_WFDOWNLOADS_ARTICLESSORT", "Default download Order:");
define("_MI_WFDOWNLOADS_ARTICLESSORTDSC", "Select the default order for the download listings.");
define("_MI_WFDOWNLOADS_TITLE", "Title");
define("_MI_WFDOWNLOADS_RATING", "Rating");
define("_MI_WFDOWNLOADS_WEIGHT", "Weight");
define("_MI_WFDOWNLOADS_POPULARITY", "Popularity");
define("_MI_WFDOWNLOADS_SUBMITTED2", "Submission Date");
define('_MI_WFDOWNLOADS_COPYRIGHT', 'Add Copright Statement to Download Detail Page?');
define('_MI_WFDOWNLOADS_COPYRIGHTDSC', '');

// Description of each config items
define('_MI_WFDOWNLOADS_USETHUMBSDSC', 'Supported file types: JPG, GIF, PNG.<br /><br />Downloads will use thumb nails for images. Set to \'No\' to use orginal image if the server does not support this option.');
define('_MI_WFDOWNLOADS_POPULARDSC', '');
define('_MI_WFDOWNLOADS_NEWDLSDSC', '');
define('_MI_WFDOWNLOADS_PERPAGEDSC', '');
define('_MI_WFDOWNLOADS_USESHOTSDSC', '');
define('_MI_WFDOWNLOADS_SHOTWIDTHDSC', '');
define('_MI_WFDOWNLOADS_REFERERSDSC', '');
define('_MI_WFDOWNLOADS_AUTOAPPROVEDSC', '');
define('_MI_WFDOWNLOADS_MAXFILESIZEDSC', '');
define('_MI_WFDOWNLOADS_IMGWIDTHDSC', '');
define('_MI_WFDOWNLOADS_IMGHEIGHTDSC', '');
define('_MI_WFDOWNLOADS_UPLOADDIRDSC', '');
define('_MI_WFDOWNLOADS_MIMETYPESDSC', '');
define('_MI_WFDOWNLOADS_ALLOWSUBMISSDSC', '');
define('_MI_WFDOWNLOADS_MAINIMGDIRDSC', '');
define('_MI_WFDOWNLOADS_SHOWDISCLAIMERDSC', '');
define('_MI_WFDOWNLOADS_SHOWDOWNDISCLDSC', '');
define('_MI_WFDOWNLOADS_DISCLAIMERDSC', '');
define('_MI_WFDOWNLOADS_PLATFORMDSC', 'List of platforms to enter <br />Separate with | IMPORTANT: Do not change this once the site is Live, Add new to the end of the list!');
define('_MI_WFDOWNLOADS_EMPTYCATSDSC', 'Select Yes to display categories with no download entries. Selecting \'No\' will hide Empty categories from the listings');
define('_MI_WFDOWNLOADS_SUBCATSDSC', 'Select Yes to display sub-categories. Selecting \'No\' will hide sub-categories from the listings');
define('_MI_WFDOWNLOADS_LICENSEDSC', 'List of platforms to enter <br />Separate with |');

// Text for notifications
define('_MI_WFDOWNLOADS_GLOBAL_NOTIFY', 'Global');
define('_MI_WFDOWNLOADS_GLOBAL_NOTIFYDSC', 'Global downloads notification options.');

define('_MI_WFDOWNLOADS_CATEGORY_NOTIFY', 'Category');
define('_MI_WFDOWNLOADS_CATEGORY_NOTIFYDSC', 'Notification options that apply to the current file category.');

define('_MI_WFDOWNLOADS_FILE_NOTIFY', 'File');
define('_MI_WFDOWNLOADS_FILE_NOTIFYDSC', 'Notification options that apply to the current file.');

define('_MI_WFDOWNLOADS_GLOBAL_NEWCATEGORY_NOTIFY', 'New Category');
define('_MI_WFDOWNLOADS_GLOBAL_NEWCATEGORY_NOTIFYCAP', 'Notify me when a new file category is created.');
define('_MI_WFDOWNLOADS_GLOBAL_NEWCATEGORY_NOTIFYDSC', 'Receive notification when a new file category is created.');
define('_MI_WFDOWNLOADS_GLOBAL_NEWCATEGORY_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New file category');                              

define('_MI_WFDOWNLOADS_GLOBAL_FILEMODIFY_NOTIFY', 'Modify File Requested');
define('_MI_WFDOWNLOADS_GLOBAL_FILEMODIFY_NOTIFYCAP', 'Notify me of any file modification request.');
define('_MI_WFDOWNLOADS_GLOBAL_FILEMODIFY_NOTIFYDSC', 'Receive notification when any file modification request is submitted.');
define('_MI_WFDOWNLOADS_GLOBAL_FILEMODIFY_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : File Modification Requested');

define('_MI_WFDOWNLOADS_GLOBAL_FILEBROKEN_NOTIFY', 'Broken File Submitted');
define('_MI_WFDOWNLOADS_GLOBAL_FILEBROKEN_NOTIFYCAP', 'Notify me of any broken file report.');
define('_MI_WFDOWNLOADS_GLOBAL_FILEBROKEN_NOTIFYDSC', 'Receive notification when any broken file report is submitted.');
define('_MI_WFDOWNLOADS_GLOBAL_FILEBROKEN_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : Broken File Reported');

define('_MI_WFDOWNLOADS_GLOBAL_FILESUBMIT_NOTIFY', 'File Submitted');
define('_MI_WFDOWNLOADS_GLOBAL_FILESUBMIT_NOTIFYCAP', 'Notify me when any new file is submitted (awaiting approval).');
define('_MI_WFDOWNLOADS_GLOBAL_FILESUBMIT_NOTIFYDSC', 'Receive notification when any new file is submitted (awaiting approval).');
define('_MI_WFDOWNLOADS_GLOBAL_FILESUBMIT_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New file submitted');

define('_MI_WFDOWNLOADS_GLOBAL_NEWFILE_NOTIFY', 'New File');
define('_MI_WFDOWNLOADS_GLOBAL_NEWFILE_NOTIFYCAP', 'Notify me when any new file is posted.');
define('_MI_WFDOWNLOADS_GLOBAL_NEWFILE_NOTIFYDSC', 'Receive notification when any new file is posted.');
define('_MI_WFDOWNLOADS_GLOBAL_NEWFILE_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New file');

define('_MI_WFDOWNLOADS_CATEGORY_FILESUBMIT_NOTIFY', 'File Submitted');
define('_MI_WFDOWNLOADS_CATEGORY_FILESUBMIT_NOTIFYCAP', 'Notify me when a new file is submitted (awaiting approval) to the current category.');   
define('_MI_WFDOWNLOADS_CATEGORY_FILESUBMIT_NOTIFYDSC', 'Receive notification when a new file is submitted (awaiting approval) to the current category.');      
define('_MI_WFDOWNLOADS_CATEGORY_FILESUBMIT_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New file submitted in category'); 

define('_MI_WFDOWNLOADS_CATEGORY_NEWFILE_NOTIFY', 'New File');
define('_MI_WFDOWNLOADS_CATEGORY_NEWFILE_NOTIFYCAP', 'Notify me when a new file is posted to the current category.');   
define('_MI_WFDOWNLOADS_CATEGORY_NEWFILE_NOTIFYDSC', 'Receive notification when a new file is posted to the current category.');      
define('_MI_WFDOWNLOADS_CATEGORY_NEWFILE_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New file in category'); 

define('_MI_WFDOWNLOADS_FILE_APPROVE_NOTIFY', 'File Approved');
define('_MI_WFDOWNLOADS_FILE_APPROVE_NOTIFYCAP', 'Notify me when this file is approved.');
define('_MI_WFDOWNLOADS_FILE_APPROVE_NOTIFYDSC', 'Receive notification when this file is approved.');
define('_MI_WFDOWNLOADS_FILE_APPROVE_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : File Approved');

define('_MI_WFD_AUTHOR_INFO', "Developer Information");
define('_MI_WFD_AUTHOR_NAME', "Developer");
define('_MI_WFD_AUTHOR_DEVTEAM', "Development Team");
define('_MI_WFD_AUTHOR_WEBSITE', "Developer website");
define('_MI_WFD_AUTHOR_EMAIL', "Developer email");
define('_MI_WFD_AUTHOR_CREDITS', "Credits");
define('_MI_WFD_MODULE_INFO', "Module Development Information");
define('_MI_WFD_MODULE_STATUS', "Development Status");
define('_MI_WFD_MODULE_DEMO', "Demo Site");
define('_MI_WFD_MODULE_SUPPORT', "Official support site");
define('_MI_WFD_MODULE_BUG', "Report a bug for this module");
define('_MI_WFD_MODULE_FEATURE', "Suggest a new feature for this module");
define('_MI_WFD_MODULE_DISCLAIMER', "Disclaimer");
define('_MI_WFD_AUTHOR_WORD', "The Author's Word");
define('_MI_WFD_RELEASE', "Release Date: ");

define('_MI_WFD_MODULE_MAILLIST', "WF-Section Mailing Lists");

define('_MI_WFD_MODULE_MAILANNOUNCEMENTS', "Announcements Mailing List");
define('_MI_WFD_MODULE_MAILBUGS', "Bug Mailing List");
define('_MI_WFD_MODULE_MAILFEATURES', "Features Mailing List");

define('_MI_WFD_MODULE_MAILANNOUNCEMENTSDSC', "Get the latest announcements from WF-Section.");
define('_MI_WFD_MODULE_MAILBUGSDSC', "Bug Tracking and submission mailing list");
define('_MI_WFD_MODULE_MAILFEATURESDSC', "Request New Features mailing list.");

define('_MI_WFD_WARNINGTEXT', "THE SOFTWARE IS PROVIDED BY WF-SECTIONS \"AS IS\" AND \"WITH ALL FAULTS.\" WF-SECTIONS MAKES NO REPRESENTATIONS OR WARRANTIES OF ANY KIND CONCERNING THE QUALITY, SAFETY OR SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT. FURTHER, ABLEMEDIA MAKES NO REPRESENTATIONS OR WARRANTIES AS TO THE TRUTH, ACCURACY OR COMPLETENESS OF ANY STATEMENTS, INFORMATION OR MATERIALS CONCERNING THE SOFTWARE THAT IS CONTAINED IN WF-SECTIONS WEBSITE. IN NO EVENT WILL ABLEMEDIA BE LIABLE FOR ANY INDIRECT, PUNITIVE, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES HOWEVER THEY MAY ARISE AND EVEN IF WF-SECTIONS HAS BEEN PREVIOUSLY ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.");
define('_MI_WFD_AUTHOR_CREDITSTEXT',"The WF-Sections Team would like to thank the following people for their help and support during the development phase of this module:<br /><br />
tom, mking, paco1969, mharoun, Talis, m0nty, steenlnielsen, Clubby, Geronimo, bd_csmc, herko, LANG, Stewdio, tedsmith, veggieryan, carnuke, MadFish.
<br /><br />And on a personal note, I would like to thank the special girl in my life who I love dearly and who gives me the strenght and support to do all of this.
");
define('_MI_WFD_AUTHOR_BUGFIXES', "Bug Fix History");
?>
