<?php
/**
 * $Id: singlefile.php v 1.03 06 july 2004 Liquid Exp $
 * Module: WF-Downloads
 * Version: v2.0.4
 * Release Date: 11 july 2004
 * Author: WF-Sections
 * Licence: GNU
 */

include "header.php";
include_once XOOPS_ROOT_PATH . "/class/xoopstree.php";

$lid = intval($_GET['lid']);
$cid = intval($_GET['cid']);
$xoopsOption['template_main'] = 'wfdownloads_singlefile.html';

$sql = "SELECT * FROM " . $xoopsDB->prefix('wfdownloads_downloads') . " WHERE lid = $lid";
$down_arr = $xoopsDB->fetchArray($xoopsDB->query($sql));

include XOOPS_ROOT_PATH . "/header.php";

/**
 * Begin Main page Heading etc
 */
$down['imageheader'] = imageheader();
$down['id'] = intval($down_arr['lid']);
$down['cid'] = intval($down_arr['cid']);
/**
 * Breadcrumb
 */
$mytree = new XoopsTree($xoopsDB->prefix("wfdownloads_cat"), "cid", "pid");
$pathstring = "<a href='index.php'>" . _MD_MAIN . "</a>&nbsp;:&nbsp;";
$pathstring .= $mytree->getNicePathFromId($cid, "title", "viewcat.php?op=");
$down['path'] = $pathstring;

include_once XOOPS_ROOT_PATH . "/modules/" . $xoopsModule->dirname() . "/include/downloadinfo.php";

$xoopsTpl->assign('show_screenshot', false);
if (isset($xoopsModuleConfig['screenshot']) && $xoopsModuleConfig['screenshot'] == 1)
{
    $xoopsTpl->assign('shots_dir', $xoopsModuleConfig['screenshots']);
    $xoopsTpl->assign('shotwidth', $xoopsModuleConfig['shotwidth']);
    $xoopsTpl->assign('shotheight', $xoopsModuleConfig['shotheight']);
    $xoopsTpl->assign('show_screenshot', true);
} 
/**
 * Show other author downloads
 */
$groups = (is_object($xoopsUser)) ? $xoopsUser->getGroups() : XOOPS_GROUP_ANONYMOUS;
$gperm_handler = &xoops_gethandler('groupperm');

$sql = "SELECT lid, cid, title, published FROM " . $xoopsDB->prefix('wfdownloads_downloads') . " 
	WHERE submitter = " . $down_arr['submitter'] . " 
	AND published > 0 AND published <= " . time() . " AND (expired = 0 OR expired > " . time() . ") 
	AND offline = 0 ORDER by published DESC";
$result = $xoopsDB->query($sql, 20, 0);

while ($arr = $xoopsDB->fetchArray($result))
{
    if (!$gperm_handler->checkRight('WFDownFilePerm', $arr['lid'], $groups, $xoopsModule->getVar('mid')) || $arr['lid'] == $lid)
        continue;
 
    $downuid['title'] = $arr['title'];
    $downuid['lid'] = $arr['lid'];
    $downuid['cid'] = $arr['cid'];
    $downuid['published'] = formatTimestamp($arr['published'], $xoopsModuleConfig['dateformat']);;
    $xoopsTpl->append('down_uid', $downuid);
} 
/**
 * User reviews
 */
$sql_review = "SELECT * FROM " . $xoopsDB->prefix('wfdownloads_reviews') . " 
	WHERE lid = " . $down_arr['lid'] . " AND submit = 1";
$result_review = $xoopsDB->query($sql_review);
$review_amount = $xoopsDB->getRowsNum($result_review);
if ($review_amount)
{
    $user_reviews = "op=list&amp;cid=" . $down_arr['cid'] . "&amp;lid=" . $down_arr['lid'] . "'>" . _MD_USERREVIEWS;
} 
else
{
    $user_reviews = "cid=" . $down_arr['cid'] . "&amp;lid=" . $down_arr['lid'] . "'>" . _MD_NOUSERREVIEWS;
} 
$xoopsTpl->assign('lang_user_reviews', $xoopsConfig['sitename'] . " " . _MD_USERREVIEWSTITLE);
$xoopsTpl->assign('lang_UserReviews', sprintf($user_reviews, $down_arr['title']));
/*
* 
*/ 
$xoopsTpl->assign('lang_title', _MD_TITLE);
$xoopsTpl->assign('lang_screenshot', _MD_SCREENSHOT);
$xoopsTpl->assign('lang_screenshot_click', _MD_SCREENSHOTCLICK);
$xoopsTpl->assign('lang_history', _MD_HISTORY);
$xoopsTpl->assign('lang_requirements', _MD_REQUIREMENTS);
$xoopsTpl->assign('lang_features', _MD_FEATURES);
$xoopsTpl->assign('lang_description', _MD_DESCRIPTIONC);
$xoopsTpl->assign('lang_lastupdate', _MD_LASTUPDATEC);
$xoopsTpl->assign('lang_hits', _MD_HITSC);
$xoopsTpl->assign('lang_ratingc', _MD_RATINGC);
$xoopsTpl->assign('lang_email', _MD_EMAILC);
$xoopsTpl->assign('lang_ratethissite', _MD_RATETHISFILE);
$xoopsTpl->assign('lang_reviewfile' , _MD_REVIEWTHISFILE);
$xoopsTpl->assign('lang_reportbroken', _MD_REPORTBROKEN);
$xoopsTpl->assign('lang_tellafriend', _MD_TELLAFRIEND);
$xoopsTpl->assign('lang_modify', _MD_MODIFY);
$xoopsTpl->assign('lang_version' , _MD_VERSION);
$xoopsTpl->assign('lang_dlnow' , _MD_DLNOW);
$xoopsTpl->assign('lang_category' , _MD_CATEGORYC);
$xoopsTpl->assign('lang_size' , _MD_FILESIZE);
$xoopsTpl->assign('lang_platform' , _MD_SUPPORTEDPLAT);
$xoopsTpl->assign('lang_homepage' , _MD_HOMEPAGE);
$xoopsTpl->assign('lang_comments' , _COMMENTS);
$xoopsTpl->assign('lang_price' , _MD_PRICE);
$xoopsTpl->assign('lang_limits' , _MD_LIMITS);
$xoopsTpl->assign('lang_mirror' , _MD_MIRROR);
$xoopsTpl->assign('lang_downloads' , _MD_DOWNLOADHITS);
$xoopsTpl->assign('lang_license' , _MD_DOWNLICENSE);
$xoopsTpl->assign('lang_submitter' , _MD_SUBMITTER);
$xoopsTpl->assign('lang_publisher' , _MD_PUBLISHER);
$xoopsTpl->assign('lang_reviews' , _MD_REVIEWS);
$xoopsTpl->assign('lang_fulldetails' , _MD_VIEWDETAILS);
$xoopsTpl->assign('lang_otherbyuid' , _MD_OTHERBYUID);
$xoopsTpl->assign('lang_downtimes' , _MD_DOWNTIMES);
$xoopsTpl->assign('lang_downloadnow', _MD_DOWNLOADNOW);
$xoopsTpl->assign('lang_inforum', _MD_INFORUM);

if (isset($xoopsModuleConfig['copyright']) && $xoopsModuleConfig['copyright'] == 1)
{
    $xoopsTpl->assign('lang_copyright', "" . $down['title'] . "  " . _MD_COPYRIGHT . " " . date("Y") . " " . XOOPS_URL);
} 
$xoopsTpl->assign('down', $down);
$xoopsTpl->assign('xoops_module', $xoopsModule->dirname());

include XOOPS_ROOT_PATH . '/include/comment_view.php';
include XOOPS_ROOT_PATH . '/footer.php';

?>
