<?php 
/**
 * $Id: xoops_version.php v 1.0.2 03 july 2004 Catwolf Exp $
 * Module: WF-Downloads
 * Version: v2.0.3
 * Release Date: 11 july 2004
 * Author: WF-Sections
 * Licence: GNU
 */

$modversion['name'] = _MI_WFDOWNLOADS_NAME;
$modversion['version'] = 2.04;
$modversion['releasedate'] = "Sunday: 11 July 2004";
$modversion['status'] = "Stable";
$modversion['description'] = _MI_WFDOWNLOADS_DESC;
$modversion['author'] = "WF-Section Team";
$modversion['credits'] = "WF-Section Team: Modifications by Catzwolf. Based on the original Mydownloads Module";
$modversion['teammembers'] = "Liquid, Rectifier, Bender, Phppp, FrankBlack, Xpider, Jazza";
$modversion['help'] = "wfdownloads.html";
$modversion['license'] = "GPL see LICENSE";
$modversion['official'] = 0;
$modversion['image'] = "images/wfdl_slogo.png";
$modversion['dirname'] = "wfdownloads";
/*
* added by Liquid. Based on code by Marcan
*/ 
$modversion['author_realname'] = "Scott Butchart";
$modversion['author_website_url'] = "http://wfsections.xoops2.com";
$modversion['author_website_name'] = "WF-Section";
$modversion['author_email'] = "webmaster@wfsections.xoops2.com";
$modversion['demo_site_url'] = "http://wfsections.xoops2.com/modules/wfdownloads/";
$modversion['demo_site_name'] = "WF-Section";
$modversion['support_site_url'] = "http://wfsections.xoops2.com/modules/newbb/index.php?cat=4";
$modversion['support_site_name'] = "WF-Downloads Support Forum";
$modversion['submit_bug'] = "http://sourceforge.net/tracker/?group_id=113004&atid=663911";
$modversion['submit_feature'] = "http://sourceforge.net/tracker/?atid=663914&group_id=113004&func=browse";
$modversion['maillist_announcements'] = "http://lists.sourceforge.net/lists/listinfo/wfsection-announcement";
$modversion['maillist_bugs'] = "http://lists.sourceforge.net/lists/listinfo/wfsection-bugs";
$modversion['maillist_features'] = "http://lists.sourceforge.net/lists/listinfo/wfsection-features";

$modversion['warning'] = _MI_WFD_WARNINGTEXT;
$modversion['author_credits'] = _MI_WFD_AUTHOR_CREDITSTEXT;

// Sql file (must contain sql generated by phpMyAdmin or phpPgAdmin)
// All tables should not have any prefix!
$modversion['sqlfile']['mysql'] = "sql/wfdownloads.sql";
// $modversion['sqlfile']['postgresql'] = "sql/pgsql.sql";
// Tables created by sql file (without prefix!)
$modversion['tables'][0] = "wfdownloads_broken";
$modversion['tables'][1] = "wfdownloads_cat";
$modversion['tables'][2] = "wfdownloads_downloads";
$modversion['tables'][3] = "wfdownloads_mod";
$modversion['tables'][4] = "wfdownloads_votedata";
$modversion['tables'][5] = "wfdownloads_indexpage";
$modversion['tables'][6] = "wfdownloads_reviews";
$modversion['tables'][7] = "wfdownloads_mimetypes";
// Admin things
$modversion['hasAdmin'] = 1;
$modversion['adminindex'] = "admin/index.php";
$modversion['adminmenu'] = "admin/menu.php";
// Blocks
$modversion['blocks'][1]['file'] = "wfdownloads_top.php";
$modversion['blocks'][1]['name'] = _MI_WFDOWNLOADS_BNAME1;
$modversion['blocks'][1]['description'] = "Shows recently added donwload files";
$modversion['blocks'][1]['show_func'] = "b_wfdownloads_top_show";
$modversion['blocks'][1]['edit_func'] = "b_wfdownloads_top_edit";
$modversion['blocks'][1]['options'] = "date|10|19";
$modversion['blocks'][1]['template'] = 'wfdownloads_block_new.html';

$modversion['blocks'][2]['file'] = "wfdownloads_top.php";
$modversion['blocks'][2]['name'] = _MI_WFDOWNLOADS_BNAME2;
$modversion['blocks'][2]['description'] = "Shows most downloaded files";
$modversion['blocks'][2]['show_func'] = "b_wfdownloads_top_show";
$modversion['blocks'][2]['edit_func'] = "b_wfdownloads_top_edit";
$modversion['blocks'][2]['options'] = "hits|10|19";
$modversion['blocks'][2]['template'] = 'wfdownloads_block_top.html';
// Menu
$modversion['hasMain'] = 1;

global $xoopsModuleConfig, $xoopsUser, $xoopsDLModule;

$submissions = 0;
$modhandler = &xoops_gethandler('module');
$xoopsDLModule = &$modhandler->getByDirname("wfdownloads");

if (is_object($xoopsDLModule) && $xoopsDLModule->getVar('isactive'))
{
    if (is_object($xoopsUser) && isset($xoopsModuleConfig['submissions']))
    {
        $groups = $xoopsUser->getGroups();
        if (array_intersect($xoopsModuleConfig['submitarts'], $groups))
        {
            $submissions = 1;
        }
    }
    else
    {
        if (isset($xoopsModuleConfig['anonpost']) && $xoopsModuleConfig['anonpost'] == 1)
        {
            $submissions = 1;
        }
    }
}

$i = 0;
if ($submissions)
{
    $i++;
    $modversion['sub'][$i]['name'] = _MI_WFDOWNLOADS_SMNAME1;
    $modversion['sub'][$i]['url'] = "submit.php";
}
$i++;
$modversion['sub'][$i]['name'] = _MI_WFDOWNLOADS_SMNAME2;
$modversion['sub'][$i]['url'] = "topten.php?list=hit";
$i++;
$modversion['sub'][$i]['name'] = _MI_WFDOWNLOADS_SMNAME3;
$modversion['sub'][$i]['url'] = "topten.php?list=rate";
unset($i);
// Search
$modversion['hasSearch'] = 1;
$modversion['search']['file'] = "include/search.inc.php";
$modversion['search']['func'] = "wfdownloads_search";
// Comments
$modversion['hasComments'] = 1;
$modversion['comments']['itemName'] = 'lid';
$modversion['comments']['pageName'] = 'singlefile.php';
$modversion['comments']['extraParams'] = array('cid');
// Comment callback functions
$modversion['comments']['callbackFile'] = 'include/comment_functions.php';
$modversion['comments']['callback']['approve'] = 'wfdownloads_com_approve';
$modversion['comments']['callback']['update'] = 'wfdownloads_com_update';
// Templates
$modversion['templates'][1]['file'] = 'wfdownloads_brokenfile.html';
$modversion['templates'][1]['description'] = '';
$modversion['templates'][2]['file'] = 'wfdownloads_download.html';
$modversion['templates'][2]['description'] = '';
$modversion['templates'][3]['file'] = 'wfdownloads_index.html';
$modversion['templates'][3]['description'] = '';
$modversion['templates'][4]['file'] = 'wfdownloads_modfile.html';
$modversion['templates'][4]['description'] = '';
$modversion['templates'][5]['file'] = 'wfdownloads_ratefile.html';
$modversion['templates'][5]['description'] = '';
$modversion['templates'][6]['file'] = 'wfdownloads_singlefile.html';
$modversion['templates'][6]['description'] = '';
$modversion['templates'][7]['file'] = 'wfdownloads_submit.html';
$modversion['templates'][7]['description'] = '';
$modversion['templates'][8]['file'] = 'wfdownloads_topten.html';
$modversion['templates'][8]['description'] = '';
$modversion['templates'][9]['file'] = 'wfdownloads_viewcat.html';
$modversion['templates'][9]['description'] = '';
$modversion['templates'][10]['file'] = 'wfdownloads_newlistindex.html';
$modversion['templates'][10]['description'] = '';
$modversion['templates'][11]['file'] = 'wfdownloads_viewlist.html';
$modversion['templates'][11]['description'] = '';
$modversion['templates'][12]['file'] = 'wfdownloads_reviews.html';
$modversion['templates'][12]['description'] = '';

//Module config setting
$modversion['config'][1]['name'] = 'popular';
$modversion['config'][1]['title'] = '_MI_WFDOWNLOADS_POPULAR';
$modversion['config'][1]['description'] = '_MI_WFDOWNLOADS_POPULARDSC';
$modversion['config'][1]['formtype'] = 'select';
$modversion['config'][1]['valuetype'] = 'int';
$modversion['config'][1]['default'] = 100;
$modversion['config'][1]['options'] = array('5' => 5, '10' => 10, '50' => 50, '100' => 100, '200' => 200, '500' => 500, '1000' => 1000);

$modversion['config'][2]['name'] = 'newdownloads';
$modversion['config'][2]['title'] = '_MI_WFDOWNLOADS_NEWDLS';
$modversion['config'][2]['description'] = '_MI_WFDOWNLOADS_NEWDLSDSC';
$modversion['config'][2]['formtype'] = 'select';
$modversion['config'][2]['valuetype'] = 'int';
$modversion['config'][2]['default'] = 10;
$modversion['config'][2]['options'] = array('5' => 5, '10' => 10, '15' => 15, '20' => 20, '25' => 25, '30' => 30, '50' => 50);

$modversion['config'][3]['name'] = 'perpage';
$modversion['config'][3]['title'] = '_MI_WFDOWNLOADS_PERPAGE';
$modversion['config'][3]['description'] = '_MI_WFDOWNLOADS_PERPAGEDSC';
$modversion['config'][3]['formtype'] = 'select';
$modversion['config'][3]['valuetype'] = 'int';
$modversion['config'][3]['default'] = 10;
$modversion['config'][3]['options'] = array('5' => 5, '10' => 10, '15' => 15, '20' => 20, '25' => 25, '30' => 30, '50' => 50);

$modversion['config'][35]['name'] = 'admin_perpage';
$modversion['config'][35]['title'] = '_MI_WFDOWNLOADS_ADMINPAGE';
$modversion['config'][35]['description'] = '_MI_WFDOWNLOADS_AMDMINPAGEDSC';
$modversion['config'][35]['formtype'] = 'select';
$modversion['config'][35]['valuetype'] = 'int';
$modversion['config'][35]['default'] = 10;
$modversion['config'][35]['options'] = array('5' => 5, '10' => 10, '15' => 15, '20' => 20, '25' => 25, '30' => 30, '50' => 50);

$modversion['config'][15]['name'] = 'submissions';
$modversion['config'][15]['title'] = '_MI_WFDOWNLOADS_ALLOWSUBMISS';
$modversion['config'][15]['description'] = '_MI_WFDOWNLOADS_ALLOWSUBMISSDSC';
$modversion['config'][15]['formtype'] = 'yesno';
$modversion['config'][15]['valuetype'] = 'int';
$modversion['config'][15]['default'] = 1;

$modversion['config'][34]['name'] = 'submitarts';
$modversion['config'][34]['title'] = '_MI_WFDOWNLOADS_SUBMITART';
$modversion['config'][34]['description'] = '_MI_WFDOWNLOADS_SUBMITARTDSC';
$modversion['config'][34]['formtype'] = 'group_multi';
$modversion['config'][34]['valuetype'] = 'array';
$modversion['config'][34]['default'] = '1';

$modversion['config'][4]['name'] = 'anonpost';
$modversion['config'][4]['title'] = '_MI_WFDOWNLOADS_ANONPOST';
$modversion['config'][4]['description'] = '';
$modversion['config'][4]['formtype'] = 'yesno';
$modversion['config'][4]['valuetype'] = 'int';
$modversion['config'][4]['default'] = 0;

$modversion['config'][5]['name'] = 'autoapprove';
$modversion['config'][5]['title'] = '_MI_WFDOWNLOADS_AUTOAPPROVE';
$modversion['config'][5]['description'] = '_MI_WFDOWNLOADS_AUTOAPPROVEDSC';
$modversion['config'][5]['formtype'] = 'yesno';
$modversion['config'][5]['valuetype'] = 'int';
$modversion['config'][5]['default'] = 0;

$qa = ' (A)';
$qd = ' (D)';

$modversion['config'][39]['name'] = 'filexorder';
$modversion['config'][39]['title'] = '_MI_WFDOWNLOADS_ARTICLESSORT';
$modversion['config'][39]['description'] = '_MI_WFDOWNLOADS_ARTICLESSORTDSC';
$modversion['config'][39]['formtype'] = 'select';
$modversion['config'][39]['valuetype'] = 'text';
$modversion['config'][39]['default'] = 'title ASC';
$modversion['config'][39]['options'] = array(_MI_WFDOWNLOADS_TITLE . $qa => 'title ASC',
    _MI_WFDOWNLOADS_TITLE . $qd => 'title DESC',
    _MI_WFDOWNLOADS_SUBMITTED2 . $qa => 'published ASC' ,
    _MI_WFDOWNLOADS_SUBMITTED2 . $qd => 'published DESC',
    _MI_WFDOWNLOADS_RATING . $qa => 'rating ASC',
    _MI_WFDOWNLOADS_RATING . $qd => 'rating DESC',
    _MI_WFDOWNLOADS_POPULARITY . $qa => 'hits ASC',
    _MI_WFDOWNLOADS_POPULARITY . $qd => 'hits DESC',
    _MI_WFDOWNLOADS_WEIGHT => 'weight');

//$modversion['config'][28]['name'] = 'emptycats';
//$modversion['config'][28]['title'] = '_MI_WFDOWNLOADS_EMPTYCATS';
//$modversion['config'][28]['description'] = '_MI_WFDOWNLOADS_EMPTYCATSDSC';
//$modversion['config'][28]['formtype'] = 'yesno';
//$modversion['config'][28]['valuetype'] = 'int';
//$modversion['config'][28]['default'] = 1;

$modversion['config'][32]['name'] = 'subcats';
$modversion['config'][32]['title'] = '_MI_WFDOWNLOADS_SUBCATS';
$modversion['config'][32]['description'] = '_MI_WFDOWNLOADS_SUBCATSDSC';
$modversion['config'][32]['formtype'] = 'yesno';
$modversion['config'][32]['valuetype'] = 'int';
$modversion['config'][32]['default'] = 0;

$modversion['config'][6]['name'] = 'screenshot';
$modversion['config'][6]['title'] = '_MI_WFDOWNLOADS_USESHOTS';
$modversion['config'][6]['description'] = '_MI_WFDOWNLOADS_USESHOTSDSC';
$modversion['config'][6]['formtype'] = 'yesno';
$modversion['config'][6]['valuetype'] = 'int';
$modversion['config'][6]['default'] = 0;

$modversion['config'][21]['name'] = 'usethumbs';
$modversion['config'][21]['title'] = '_MI_WFDOWNLOADS_USETHUMBS';
$modversion['config'][21]['description'] = '_MI_WFDOWNLOADS_USETHUMBSDSC';
$modversion['config'][21]['formtype'] = 'yesno';
$modversion['config'][21]['valuetype'] = 'int';
$modversion['config'][21]['default'] = 0;

$modversion['config'][36]['name'] = 'updatethumbs';
$modversion['config'][36]['title'] = '_MI_WFDOWNLOADS_IMGUPDATE';
$modversion['config'][36]['description'] = '_MI_WFDOWNLOADS_IMGUPDATEDSC';
$modversion['config'][36]['formtype'] = 'yesno';
$modversion['config'][36]['valuetype'] = 'int';
$modversion['config'][36]['default'] = 1;

$modversion['config'][37]['name'] = 'imagequality';
$modversion['config'][37]['title'] = '_MI_WFDOWNLOADS_QUALITY';
$modversion['config'][37]['description'] = '_MI_WFDOWNLOADS_QUALITYDSC';
$modversion['config'][37]['formtype'] = 'textbox';
$modversion['config'][37]['valuetype'] = 'int';
$modversion['config'][37]['default'] = 100;

$modversion['config'][38]['name'] = 'keepaspect';
$modversion['config'][38]['title'] = '_MI_WFDOWNLOADS_KEEPASPECT';
$modversion['config'][38]['description'] = '_MI_WFDOWNLOADS_KEEPASPECTDSC';
$modversion['config'][38]['formtype'] = 'yesno';
$modversion['config'][38]['valuetype'] = 'int';
$modversion['config'][38]['default'] = 0;

$modversion['config'][7]['name'] = 'shotwidth';
$modversion['config'][7]['title'] = '_MI_WFDOWNLOADS_SHOTWIDTH';
$modversion['config'][7]['description'] = '_MI_WFDOWNLOADS_SHOTWIDTHDSC';
$modversion['config'][7]['formtype'] = 'textbox';
$modversion['config'][7]['valuetype'] = 'int';
$modversion['config'][7]['default'] = 140;

$modversion['config'][20]['name'] = 'shotheight';
$modversion['config'][20]['title'] = '_MI_WFDOWNLOADS_SHOTHEIGHT';
$modversion['config'][20]['description'] = '_MI_WFDOWNLOADS_SHOTHEIGHTDSC';
$modversion['config'][20]['formtype'] = 'textbox';
$modversion['config'][20]['valuetype'] = 'int';
$modversion['config'][20]['default'] = 79;

$modversion['config'][8]['name'] = 'check_host';
$modversion['config'][8]['title'] = '_MI_WFDOWNLOADS_CHECKHOST';
$modversion['config'][8]['description'] = '';
$modversion['config'][8]['formtype'] = 'yesno';
$modversion['config'][8]['valuetype'] = 'int';
$modversion['config'][8]['default'] = 0;

$xoops_url = parse_url(XOOPS_URL);
$modversion['config'][9]['name'] = 'referers';
$modversion['config'][9]['title'] = '_MI_WFDOWNLOADS_REFERERS';
$modversion['config'][9]['description'] = '_MI_WFDOWNLOADS_REFERERSDSC';
$modversion['config'][9]['formtype'] = 'textarea';
$modversion['config'][9]['valuetype'] = 'array';
$modversion['config'][9]['default'] = array($xoops_url['host']);

$modversion['config'][16]['name'] = 'useruploads';
$modversion['config'][16]['title'] = '_MI_WFDOWNLOADS_ALLOWUPLOADS';
$modversion['config'][16]['description'] = '_MI_WFDOWNLOADS_ALLOWUPLOADSDSC';
$modversion['config'][16]['formtype'] = 'yesno';
$modversion['config'][16]['valuetype'] = 'int';
$modversion['config'][16]['default'] = 0;

$modversion['config'][10]['name'] = 'maxfilesize';
$modversion['config'][10]['title'] = '_MI_WFDOWNLOADS_MAXFILESIZE';
$modversion['config'][10]['description'] = '_MI_WFDOWNLOADS_MAXFILESIZEDSC';
$modversion['config'][10]['formtype'] = 'textbox';
$modversion['config'][10]['valuetype'] = 'int';
$modversion['config'][10]['default'] = 200000;

$modversion['config'][11]['name'] = 'maximgwidth';
$modversion['config'][11]['title'] = '_MI_WFDOWNLOADS_IMGWIDTH';
$modversion['config'][11]['description'] = '_MI_WFDOWNLOADS_IMGWIDTHDSC';
$modversion['config'][11]['formtype'] = 'textbox';
$modversion['config'][11]['valuetype'] = 'int';
$modversion['config'][11]['default'] = 600;

$modversion['config'][12]['name'] = 'maximgheight';
$modversion['config'][12]['title'] = '_MI_WFDOWNLOADS_IMGHEIGHT';
$modversion['config'][12]['description'] = '_MI_WFDOWNLOADS_IMGHEIGHTDSC';
$modversion['config'][12]['formtype'] = 'textbox';
$modversion['config'][12]['valuetype'] = 'int';
$modversion['config'][12]['default'] = 600;

$modversion['config'][13]['name'] = 'uploaddir';
$modversion['config'][13]['title'] = '_MI_WFDOWNLOADS_UPLOADDIR';
$modversion['config'][13]['description'] = '_MI_WFDOWNLOADS_UPLOADDIRDSC';
$modversion['config'][13]['formtype'] = 'textbox';
$modversion['config'][13]['valuetype'] = 'text';
$modversion['config'][13]['default'] = 'uploads';

$modversion['config'][19]['name'] = 'mainimagedir';
$modversion['config'][19]['title'] = '_MI_WFDOWNLOADS_MAINIMGDIR';
$modversion['config'][19]['description'] = '_MI_WFDOWNLOADS_MAINIMGDIRDSC';
$modversion['config'][19]['formtype'] = 'textbox';
$modversion['config'][19]['valuetype'] = 'text';
$modversion['config'][19]['default'] = 'modules/wfdownloads/images';

$modversion['config'][17]['name'] = 'screenshots';
$modversion['config'][17]['title'] = '_MI_WFDOWNLOADS_SCREENSHOTS';
$modversion['config'][17]['description'] = '_MI_WFDOWNLOADS_SCREENSHOTSDSC';
$modversion['config'][17]['formtype'] = 'textbox';
$modversion['config'][17]['valuetype'] = 'text';
$modversion['config'][17]['default'] = 'modules/wfdownloads/images/screenshots';

$modversion['config'][18]['name'] = 'catimage';
$modversion['config'][18]['title'] = '_MI_WFDOWNLOADS_CATEGORYIMG';
$modversion['config'][18]['description'] = '_MI_WFDOWNLOADS_CATEGORYIMGDSC';
$modversion['config'][18]['formtype'] = 'textbox';
$modversion['config'][18]['valuetype'] = 'text';
$modversion['config'][18]['default'] = 'modules/wfdownloads/images/category';

$modversion['config'][26]['name'] = 'platform';
$modversion['config'][26]['title'] = '_MI_WFDOWNLOADS_PLATFORM';
$modversion['config'][26]['description'] = '_MI_WFDOWNLOADS_PLATFORMDSC';
$modversion['config'][26]['formtype'] = 'textarea';
$modversion['config'][26]['valuetype'] = 'array';
$modversion['config'][26]['default'] = 'None|Windows|Unix|Mac|Xoops 1.3|Xoops2.0|xoops 2.0.5|Xoops 2.0.6|Xoops 2.0.7|Other';

$license = 'Apache License (v. 1.0)|
Apache License (v. 1.1) |
Attribution Assurance License |
Berkeley Database License |
4.4 BSD Copyright (Original BSD-Lizenz) |
FreeBSD Copyright (Modifizierte BSD-Lizenz) |
BSD License (Original)|
Christian Software Public License|
Cryptix General License| 
Eiffel Forum License (v. 1.0)|
Eiffel Forum License (v. 2.0)|
Free Fuzzy Logic Library Open Source License| 
Intel Open Source License for CDSA/CSSM Implementation| 
Lua Copyright notice| 
MIT License|
Mozart License|
OpenLDAP Public License (v. 2.3)| 
OpenLDAP Public License (v. 2.5)|
OpenLDAP Public License (v. 2.7)|
Open Media Group Open Source License|
Pangeia Informatica Copyright (v. 1.2)|
Phorum License (v. 2.0)|
PHP License (v. 3.0)|
PLT License|
Python Copyright|
skyBuilders Open Source License|
Sleepycat Software Product License|
SpectSoft General Open Source License (SGOSL)|
4Suite License (v. 1.1)|
Tea Software License|
UdanaxTM Open-Source License|
Vovida Software License|
W3C Software Notice and License|
Wide Open License (WOL)|
X.Net License|
X Window System License|
The license of ZLib|
Zope Public License (v. 2.0)| 
Academic Free License (AFL) (v. 1.1)|
Academic Free License (AFL) (v. 1.2)| 
CNRI Open Source License Agreement (bis Python 1.6)|
Galen Open Source License (GOSL)|
Globus Toolkit Public License|
Open Group Test Suite License|
PSF License Agreement (Python)| 
Ruby License|
Sendmail License|
SFL License Agreement| 
Standard ML of New Jersey Copyright Notice|
Suneido Free Software License|
Tcl/Tk License Terms|
xinetd License|
Zope Public License (v. 1.0)|
Affero General Public License|
Alternate Route Open Source License (v. 2.0)|
GNU Emacs General Public License|
GNU General Public License (GPL) (v. 1.0)|
GNU General Public License (GPL) (v. 2.0)|
Open RTLinux Patent License (v. 2.0)|
Apple Public Source License (v. 2.0)|
Arphic Public License|
Common Public License|
IBM Public License|
Jabber Open Source License|
Nethack General Public License|
Open Group Public License|
Open Software License (OSL) (v. 1.0)|
Open Software License (OSL) (v. 1.1)|
Open Software License (OSL) (v 2.0)|
RedHat eCos Public License (v. 1.1)| 
Salutation Public License|
Software AG License Terms (Quip License) (v. 1.3)|
Vim License|
Erlang Public License (v. 1.1)|
ICS Open Source Public License|
Interbase Public License|
Mozilla Public License (v. 1.0)|
Mozilla Public License (v. 1.1)|
Netizen Open Source License (NOSL)|
Nokia Open Source License|
Open Telecom Public License|
Ricoh Source Code Public License|
Sun Public License|
Sun Industry Standards Source License (v. 1.1)|
Zenplex Public License|
Cougaar Open Source License|
Hi-Potent Open Source License | 
GNU Library General Public License (LGPL) (v. 2.0)| 
GNU Lesser General Public License (LGPL) (v. 2.1)| 
Motosoto Open Source License (v. 0.9.1)|
Open Watcom Public License|
Artistic License (v. 1.0)| 
Artistic License (v. 2.0)| 
Clarified Artistic License| 
Keith Devens Open Source License|
LaTeX Project Public License (LPPL) (v. 1.2)| 
Physnet Package License|
SGI Free Software License B (v. 1.1)| 
Apple Public Source License (v. 1.2)| 
Macromedia Open Source License Agreement (v. 1.0)|
Netscape Public License (NPL) (v. 1.0)|
Netscape Public License (NPL) (v. 1.1)|
OCLC Research Public License (v. 1.0)|
OCLC Research Public License (v. 2.0)|
Open Map Software License Agreement| 
Q Public License (QPL)|
Aladdin Free Public License (v. 8.0)|
Aladdin Free Public License (v. 9.0)| 
AT&T Source Code Agreement (v. 1.2D)| 
CenterPoint Public License|
CrossPoint Quelltext Lizenz|
Hacktivismo Enhanced-Source Software License Agreement (v. 0.1)|
Jahia Community Source License (JSCL) (v.012)|
Microsoft Shared Source License| 
Open Public License|
Open RTLinux Patent License (v. 1.0)|
Plan 9 Open Source License Agreement| 
PLS Free Software License Agreement (v. 1.0)|
Real Networks Community Source License (v. 1.2)| 
Red Hat eCos Public License (v. 1.1)| 
Scilab license| 
SGI Free Software License B (v. 1.0)|  
ShippySoft Source Available License (SSSAL)| 
Squeak License (Apple)| 
Sun Community Source License| 
Sun Solaris Source Code (Foundation Release) License (v. 1.1)| 
University of Utah Public License| 
YaST and SuSE Linux license terms| 
YaST und SuSE Linux Lizenzbestimmungen| 
ZIB Academic License| 
Apples Common Documentation License (v. 1.0)| 
Creative Commons Licenses| 
Design Science License (DSL)| 
EFF Audio Public License (v. 1.0.1) | 
electrohippies Ethical Open License (v. 2.0)| 
electronic Music Public License| 
Ethymonics Free Music License| 
Free Art License| 
Lizenz (Freie Kunst)|
FreeBSD Documentation License| 
Free Music Public License (FMPL) (v. 0.7)| 
GNU Free Documentation License (FDL) (v. 1.1)| 
GNU Free Documentation License (FDL) (v. 1.2)| 
Guy Hoffmans license| 
Linux Documentation Project Copying License| 
Lizenz fr Freie Inhalte|
Lizenz fr die freie Nutzung unvernderter Inhalte| 
October Open Game License (OOGL)| 
The Open Book Project| 
Open Content License (OPL)| 
Open Directory Project License| 
Open Game License| 
The green Open Music Licence| 
The yellow Open Music License| 
The red Open Music License| 
The rainbow Open Music License| 
Open Publication License (v. 1.0)| 
Open Source Music License (OSML)| 
OR Magazine License| 
Public Documentation License (PDL)'; 

$modversion['config'][27]['name'] = 'license';
$modversion['config'][27]['title'] = '_MI_WFDOWNLOADS_LICENSE';
$modversion['config'][27]['description'] = '_MI_WFDOWNLOADS_LICENSEDSC';
$modversion['config'][27]['formtype'] = 'textarea';
$modversion['config'][27]['valuetype'] = 'array';
$modversion['config'][27]['default'] = $license;

$modversion['config'][33]['name'] = 'versiontypes';
$modversion['config'][33]['title'] = '_MI_WFDOWNLOADS_VERSIONTYPES';
$modversion['config'][33]['description'] = '_MI_WFDOWNLOADS_PLATFORMDSC';
$modversion['config'][33]['formtype'] = 'textarea';
$modversion['config'][33]['valuetype'] = 'array';
$modversion['config'][33]['default'] = 'None|Alpha|Beta|RC|FULL';

$modversion['config'][31]['name'] = 'limitations';
$modversion['config'][31]['title'] = '_MI_WFDOWNLOADS_LIMITS';
$modversion['config'][31]['description'] = '_MI_WFDOWNLOADS_LIMITSDSC';
$modversion['config'][31]['formtype'] = 'textarea';
$modversion['config'][31]['valuetype'] = 'array';
$modversion['config'][31]['default'] = 'None|Trial|14 day limitaion|None Save';

$modversion['config'][23]['name'] = 'dateformat';
$modversion['config'][23]['title'] = '_MI_WFDOWNLOADS_DATEFORMAT';
$modversion['config'][23]['description'] = '_MI_WFDOWNLOADS_DATEFORMATDSC';
$modversion['config'][23]['formtype'] = 'textbox';
$modversion['config'][23]['valuetype'] = 'text';
$modversion['config'][23]['default'] = 'D, d-M-Y';

$modversion['config'][24]['name'] = 'showdisclaimer';
$modversion['config'][24]['title'] = '_MI_WFDOWNLOADS_SHOWDISCLAIMERS';
$modversion['config'][24]['description'] = '_MI_WFDOWNLOADS_SHOWDISCLAIMERSDSC';
$modversion['config'][24]['formtype'] = 'yesno';
$modversion['config'][24]['valuetype'] = 'int';
$modversion['config'][24]['default'] = 0;

$modversion['config'][25]['name'] = 'disclaimer';
$modversion['config'][25]['title'] = '_MI_WFDOWNLOADS_DISCLAIMER';
$modversion['config'][25]['description'] = '';
$modversion['config'][25]['formtype'] = 'textarea';
$modversion['config'][25]['valuetype'] = 'text';
$modversion['config'][25]['default'] = "We have the right, but not the obligation to monitor and review submissions submitted by users, in the forums. We shall not be responsible for any of the content of these messages. We further reserve the right, to delete, move or edit submissions that the we, in its exclusive discretion, deems abusive, defamatory, obscene or in violation of any Copyright or Trademark laws or otherwise objectionable.";

$modversion['config'][29]['name'] = 'showDowndisclaimer';
$modversion['config'][29]['title'] = '_MI_WFDOWNLOADS_SHOWDOWNDISCL';
$modversion['config'][29]['description'] = '_MI_WFDOWNLOADS_SHOWDOWNDISCLDSC';
$modversion['config'][29]['formtype'] = 'yesno';
$modversion['config'][29]['valuetype'] = 'int';
$modversion['config'][29]['default'] = 0;

$modversion['config'][30]['name'] = 'downdisclaimer';
$modversion['config'][30]['title'] = '_MI_WFDOWNLOADS_DOWNDISCLAIMER';
$modversion['config'][30]['description'] = '';
$modversion['config'][30]['formtype'] = 'textarea';
$modversion['config'][30]['valuetype'] = 'text';
$modversion['config'][30]['default'] = 'The file downloads on this site are provided as is without warranty either expressed or implied. Downloaded files should be checked for possible virus infection using the most up-to-date detection and security packages. If you have a question concerning a particular piece of software, feel free to contact the developer. We refuse liability for any damage or loss resulting from the use or misuse of any software offered from this site for downloading. If you have any doubt at all about the safety and operation of software made available to you on this site, do not download it.

Contact us if you have questions concerning this disclaimer.
';

$modversion['config'][40]['name'] = 'copyright';
$modversion['config'][40]['title'] = '_MI_WFDOWNLOADS_COPYRIGHT';
$modversion['config'][40]['description'] = '';
$modversion['config'][40]['formtype'] = 'yesno';
$modversion['config'][40]['valuetype'] = 'int';
$modversion['config'][40]['default'] = 1;

// Notification
$modversion['hasNotification'] = 1;
$modversion['notification']['lookup_file'] = 'include/notification.inc.php';
$modversion['notification']['lookup_func'] = 'wfdownloads_notify_iteminfo';

$modversion['notification']['category'][1]['name'] = 'global';
$modversion['notification']['category'][1]['title'] = _MI_WFDOWNLOADS_GLOBAL_NOTIFY;
$modversion['notification']['category'][1]['description'] = _MI_WFDOWNLOADS_GLOBAL_NOTIFYDSC;
$modversion['notification']['category'][1]['subscribe_from'] = array('index.php', 'viewcat.php', 'singlefile.php');

$modversion['notification']['category'][2]['name'] = 'category';
$modversion['notification']['category'][2]['title'] = _MI_WFDOWNLOADS_CATEGORY_NOTIFY;
$modversion['notification']['category'][2]['description'] = _MI_WFDOWNLOADS_CATEGORY_NOTIFYDSC;
$modversion['notification']['category'][2]['subscribe_from'] = array('viewcat.php', 'singlefile.php');
$modversion['notification']['category'][2]['item_name'] = 'cid';
$modversion['notification']['category'][2]['allow_bookmark'] = 1;

$modversion['notification']['category'][3]['name'] = 'file';
$modversion['notification']['category'][3]['title'] = _MI_WFDOWNLOADS_FILE_NOTIFY;
$modversion['notification']['category'][3]['description'] = _MI_WFDOWNLOADS_FILE_NOTIFYDSC;
$modversion['notification']['category'][3]['subscribe_from'] = 'singlefile.php';
$modversion['notification']['category'][3]['item_name'] = 'lid';
$modversion['notification']['category'][3]['allow_bookmark'] = 1;

$modversion['notification']['event'][1]['name'] = 'new_category';
$modversion['notification']['event'][1]['category'] = 'global';
$modversion['notification']['event'][1]['title'] = _MI_WFDOWNLOADS_GLOBAL_NEWCATEGORY_NOTIFY;
$modversion['notification']['event'][1]['caption'] = _MI_WFDOWNLOADS_GLOBAL_NEWCATEGORY_NOTIFYCAP;
$modversion['notification']['event'][1]['description'] = _MI_WFDOWNLOADS_GLOBAL_NEWCATEGORY_NOTIFYDSC;
$modversion['notification']['event'][1]['mail_template'] = 'global_newcategory_notify';
$modversion['notification']['event'][1]['mail_subject'] = _MI_WFDOWNLOADS_GLOBAL_NEWCATEGORY_NOTIFYSBJ;

$modversion['notification']['event'][2]['name'] = 'file_modify';
$modversion['notification']['event'][2]['category'] = 'global';
$modversion['notification']['event'][2]['admin_only'] = 1;
$modversion['notification']['event'][2]['title'] = _MI_WFDOWNLOADS_GLOBAL_FILEMODIFY_NOTIFY;
$modversion['notification']['event'][2]['caption'] = _MI_WFDOWNLOADS_GLOBAL_FILEMODIFY_NOTIFYCAP;
$modversion['notification']['event'][2]['description'] = _MI_WFDOWNLOADS_GLOBAL_FILEMODIFY_NOTIFYDSC;
$modversion['notification']['event'][2]['mail_template'] = 'global_filemodify_notify';
$modversion['notification']['event'][2]['mail_subject'] = _MI_WFDOWNLOADS_GLOBAL_FILEMODIFY_NOTIFYSBJ;

$modversion['notification']['event'][3]['name'] = 'file_broken';
$modversion['notification']['event'][3]['category'] = 'global';
$modversion['notification']['event'][3]['admin_only'] = 1;
$modversion['notification']['event'][3]['title'] = _MI_WFDOWNLOADS_GLOBAL_FILEBROKEN_NOTIFY;
$modversion['notification']['event'][3]['caption'] = _MI_WFDOWNLOADS_GLOBAL_FILEBROKEN_NOTIFYCAP;
$modversion['notification']['event'][3]['description'] = _MI_WFDOWNLOADS_GLOBAL_FILEBROKEN_NOTIFYDSC;
$modversion['notification']['event'][3]['mail_template'] = 'global_filebroken_notify';
$modversion['notification']['event'][3]['mail_subject'] = _MI_WFDOWNLOADS_GLOBAL_FILEBROKEN_NOTIFYSBJ;

$modversion['notification']['event'][4]['name'] = 'file_submit';
$modversion['notification']['event'][4]['category'] = 'global';
$modversion['notification']['event'][4]['admin_only'] = 1;
$modversion['notification']['event'][4]['title'] = _MI_WFDOWNLOADS_GLOBAL_FILESUBMIT_NOTIFY;
$modversion['notification']['event'][4]['caption'] = _MI_WFDOWNLOADS_GLOBAL_FILESUBMIT_NOTIFYCAP;
$modversion['notification']['event'][4]['description'] = _MI_WFDOWNLOADS_GLOBAL_FILESUBMIT_NOTIFYDSC;
$modversion['notification']['event'][4]['mail_template'] = 'global_filesubmit_notify';
$modversion['notification']['event'][4]['mail_subject'] = _MI_WFDOWNLOADS_GLOBAL_FILESUBMIT_NOTIFYSBJ;

$modversion['notification']['event'][5]['name'] = 'new_file';
$modversion['notification']['event'][5]['category'] = 'global';
$modversion['notification']['event'][5]['title'] = _MI_WFDOWNLOADS_GLOBAL_NEWFILE_NOTIFY;
$modversion['notification']['event'][5]['caption'] = _MI_WFDOWNLOADS_GLOBAL_NEWFILE_NOTIFYCAP;
$modversion['notification']['event'][5]['description'] = _MI_WFDOWNLOADS_GLOBAL_NEWFILE_NOTIFYDSC;
$modversion['notification']['event'][5]['mail_template'] = 'global_newfile_notify';
$modversion['notification']['event'][5]['mail_subject'] = _MI_WFDOWNLOADS_GLOBAL_NEWFILE_NOTIFYSBJ;

$modversion['notification']['event'][6]['name'] = 'file_submit';
$modversion['notification']['event'][6]['category'] = 'category';
$modversion['notification']['event'][6]['admin_only'] = 1;
$modversion['notification']['event'][6]['title'] = _MI_WFDOWNLOADS_CATEGORY_FILESUBMIT_NOTIFY;
$modversion['notification']['event'][6]['caption'] = _MI_WFDOWNLOADS_CATEGORY_FILESUBMIT_NOTIFYCAP;
$modversion['notification']['event'][6]['description'] = _MI_WFDOWNLOADS_CATEGORY_FILESUBMIT_NOTIFYDSC;
$modversion['notification']['event'][6]['mail_template'] = 'category_filesubmit_notify';
$modversion['notification']['event'][6]['mail_subject'] = _MI_WFDOWNLOADS_CATEGORY_FILESUBMIT_NOTIFYSBJ;

$modversion['notification']['event'][7]['name'] = 'new_file';
$modversion['notification']['event'][7]['category'] = 'category';
$modversion['notification']['event'][7]['title'] = _MI_WFDOWNLOADS_CATEGORY_NEWFILE_NOTIFY;
$modversion['notification']['event'][7]['caption'] = _MI_WFDOWNLOADS_CATEGORY_NEWFILE_NOTIFYCAP;
$modversion['notification']['event'][7]['description'] = _MI_WFDOWNLOADS_CATEGORY_NEWFILE_NOTIFYDSC;
$modversion['notification']['event'][7]['mail_template'] = 'category_newfile_notify';
$modversion['notification']['event'][7]['mail_subject'] = _MI_WFDOWNLOADS_CATEGORY_NEWFILE_NOTIFYSBJ;

$modversion['notification']['event'][8]['name'] = 'approve';
$modversion['notification']['event'][8]['category'] = 'file';
$modversion['notification']['event'][8]['invisible'] = 1;
$modversion['notification']['event'][8]['title'] = _MI_WFDOWNLOADS_FILE_APPROVE_NOTIFY;
$modversion['notification']['event'][8]['caption'] = _MI_WFDOWNLOADS_FILE_APPROVE_NOTIFYCAP;
$modversion['notification']['event'][8]['description'] = _MI_WFDOWNLOADS_FILE_APPROVE_NOTIFYDSC;
$modversion['notification']['event'][8]['mail_template'] = 'file_approve_notify';
$modversion['notification']['event'][8]['mail_subject'] = _MI_WFDOWNLOADS_FILE_APPROVE_NOTIFYSBJ;

?>
